#include "configi.h"
#include <qsettings.h>
#include <qmessagebox.h>
#include <qlineedit.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qregexp.h>
#include <qcheckbox.h>
#include <qtimer.h>
#include <qcombobox.h>
#include <qspinbox.h>
#include <stdlib.h>
#include <qapplication.h>
#include <qdir.h>
#include <qlistview.h>
#include <qradiobutton.h>
#include <qpopupmenu.h>
#include <qfiledialog.h>
#include <qfont.h>
#include <qtabwidget.h>

//GLOBALES
extern QString mameinfoF;
extern QString mamehistoryF;
extern QString mameromdirF;

extern QString argumentosMame;
extern QString fxmame;

extern QString snapshots;
extern QString flyers;
extern QString cabinets;
extern QString titles;
extern QString marquees;



configi::configi(QWidget *parent, const char *name ) : config(parent,name) {
//CONSTRUCTOR

QSettings conf;
x11->setText(conf.readEntry( "/qtmame/general/fxmame", "xmame.x11" ));

//fuentes
QFont font;
font.fromString( conf.readEntry( "/qtmame/general/fuenteConfig", "" ) );
Tab1->setFont(font);

listaDirectorios->setSorting(-1,TRUE);
QTimer::singleShot( 100, this, SLOT(leerconfig()) );
}

configi::~configi(){
//fuentes y colores
QSettings conf;
conf.writeEntry( "/qtmame/general/fuenteConfig",  this->font().toString());
//DESTRUCTOR
}

void configi::aceptar(){
//graba la Configuracion
QSettings conf;
QString temp1;

argumentosMame="";
argumentosMame.append("-nolcf ");

//SOUND
if (dsppluginS->text().compare("")!=0) {
     argumentosMame.append("-dsp-plugin ");
     argumentosMame.append(dsppluginS->text());
     argumentosMame.append(" ");
}

//if (timerS->isChecked()) argumentosMame.append("-timer ");
//else argumentosMame.append("-notimer ");

if (soundmixerpluginS->text().compare("")!=0) {
     argumentosMame.append("-sound-mixer-plugin ");
     argumentosMame.append(soundmixerpluginS->text());
     argumentosMame.append(" ");
}

if (soundS->isChecked()) argumentosMame.append("-sound ");
else argumentosMame.append("-nosound ");

if (samplesS->isChecked()) argumentosMame.append("-samples ");
else argumentosMame.append("-nosamples ");


argumentosMame.append("-samplefreq ");
argumentosMame.append(samplefreqS->currentText());
argumentosMame.append(" ");

argumentosMame.append("-bufsize ");
argumentosMame.append(bufsizeS->text());
argumentosMame.append(" ");

argumentosMame.append("-volume ");
argumentosMame.append(volumeS->text());
argumentosMame.append(" ");

if (audiodeviceS->text().compare("")!=0) {
     argumentosMame.append("-audiodevice ");
     argumentosMame.append(audiodeviceS->text());
     argumentosMame.append(" ");
}

if (mixerdeviceS->text().compare("")!=0) {
     argumentosMame.append("-mixerdevice ");
     argumentosMame.append(mixerdeviceS->text());
     argumentosMame.append(" ");
}
//INPUT
argumentosMame.append("-joytype ");
argumentosMame.append(joytypeC->currentText());
argumentosMame.append(" ");

if (analogstickC->isChecked()) argumentosMame.append("-analogstick ");
else argumentosMame.append("-noanalogstick ");

if (mouseC->isChecked()) argumentosMame.append("-mouse ");
else argumentosMame.append("-nomouse ");

if (hotrodC->isChecked()) argumentosMame.append("-hotrod ");
else argumentosMame.append("-nohotrod ");

if (hotrodseC->isChecked()) argumentosMame.append("-hotrodse ");
else argumentosMame.append("-nohotrodse ");

if (usbpspadC->isChecked()) argumentosMame.append("-usbpspad ");
else argumentosMame.append("-nousbpspad ");

if (rapidfireC->isChecked()) argumentosMame.append("-rapidfire ");
else argumentosMame.append("-norapidfire ");

if (grabmouseC->isChecked()) argumentosMame.append("-grabmouse ");
else argumentosMame.append("-nograbmouse ");

if (winkeysC->isChecked()) argumentosMame.append("-winkeys ");
else argumentosMame.append("-nowinkeys ");

if (joydevnameC->text().compare("")!=0) {
     argumentosMame.append("-joydevname ");
     argumentosMame.append(joydevnameC->text());
     argumentosMame.append(" ");
}
// OTROS

if (cheatO->isChecked()) argumentosMame.append("-cheat ");
else argumentosMame.append("-nocheat ");

if (skipGameInfoO->isChecked()) argumentosMame.append("-skip_gameinfo ");
else argumentosMame.append("-noskip_gameinfo ");

if (skipDisclaimerO->isChecked()) argumentosMame.append("-skip_disclaimer ");
else argumentosMame.append("-noskip_disclaimer ");

//VIDEO
if (fullscreenV->isChecked()) argumentosMame.append("-fullscreen ");
else argumentosMame.append("-nofullscreen ");

//if (cursorV->isChecked()) argumentosMame.append("-cursor ");
//else argumentosMame.append("-nocursor ");

//directorios
QListViewItem * item;
//
item=listaDirectorios->findItem ( "Mameinfo", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
if (temp1.compare("")!=0) {
     argumentosMame.append("-mameinfo_file ");
     argumentosMame.append(temp1);
     argumentosMame.append(" ");
}
//
item=listaDirectorios->findItem ( "History", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
if (temp1.compare("")!=0) {
     argumentosMame.append("-history_file ");
     argumentosMame.append(temp1);
     argumentosMame.append(" ");
}
//
item=listaDirectorios->findItem ( "Cheat", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
if (temp1.compare("")!=0) {
     argumentosMame.append("-cheat_file ");
     argumentosMame.append(temp1);
     argumentosMame.append(" ");
}
//
item=listaDirectorios->findItem ( "HiscoreFile", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
if (temp1.compare("")!=0) {
     argumentosMame.append("-hiscore_file ");
     argumentosMame.append(temp1);
     argumentosMame.append(" ");
}
//
item=listaDirectorios->findItem ( "Snapshots", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
if (temp1.compare("")!=0) {
     argumentosMame.append("-snapshot_directory ");
     argumentosMame.append(temp1);
     snapshots=temp1;
     argumentosMame.append(" ");
}
//
item=listaDirectorios->findItem ( "Nvram", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
if (temp1.compare("")!=0) {
     argumentosMame.append("-nvram_directory ");
     argumentosMame.append(temp1);
     argumentosMame.append(" ");
}
//
item=listaDirectorios->findItem ( "Memcard", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
if (temp1.compare("")!=0) {
     argumentosMame.append("-memcard_directory ");
     argumentosMame.append(temp1);
     argumentosMame.append(" ");
}
//
item=listaDirectorios->findItem ( "Input", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
if (temp1.compare("")!=0) {
     argumentosMame.append("-input_directory ");
     argumentosMame.append(temp1);
     argumentosMame.append(" ");
}
//
item=listaDirectorios->findItem ( "Cfg", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
if (temp1.compare("")!=0) {
     argumentosMame.append("-cfg_directory ");
     argumentosMame.append(temp1);
     argumentosMame.append(" ");
}
//
item=listaDirectorios->findItem ( "Samples", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
if (temp1.compare("")!=0) {
     argumentosMame.append("-samplepath ");
     argumentosMame.append(temp1);
     argumentosMame.append(" ");
}
//
item=listaDirectorios->findItem ( "Hiscore", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
if (temp1.compare("")!=0) {
     argumentosMame.append("-hiscore_directory ");
     argumentosMame.append(temp1);
     argumentosMame.append(" ");
}
//
item=listaDirectorios->findItem ( "Artwork", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
if (temp1.compare("")!=0) {
     argumentosMame.append("-artwork_directory ");
     argumentosMame.append(temp1);
     argumentosMame.append(" ");
}
//
item=listaDirectorios->findItem ( "Ctrlr", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
if (temp1.compare("")!=0) {
     argumentosMame.append("-ctrlr_directory ");
     argumentosMame.append(temp1);
     argumentosMame.append(" ");
}
//
item=listaDirectorios->findItem ( "Diff", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
if (temp1.compare("")!=0) {
     argumentosMame.append("-diff_directory ");
     argumentosMame.append(temp1);
     argumentosMame.append(" ");
}
//
item=listaDirectorios->findItem ( "Roms", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
if (temp1.compare("")!=0) {
     argumentosMame.append("-rompath ");
     argumentosMame.append(temp1);
     argumentosMame.append(" ");
}

if (moreOptions->text().compare("")!=0) {
     argumentosMame.append(moreOptions->text());
}


conf.writeEntry( "/qtmame/general/argumentosmame", argumentosMame );      

//graba info de directorios
item=listaDirectorios->findItem ( "Base-Mame", 0, ExactMatch );
temp1=item->text(1);
conf.writeEntry( "/qtmame/general/basemame", temp1 );
//
item=listaDirectorios->findItem ( "History", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
conf.writeEntry( "/qtmame/general/mamehistory", temp1 );
//
item=listaDirectorios->findItem ( "Roms", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
conf.writeEntry( "/qtmame/general/mameromdir", temp1 );
mameromdirF=temp1;
//
item=listaDirectorios->findItem ( "Snapshots", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
conf.writeEntry( "/qtmame/general/snapshots", temp1 );
//
item=listaDirectorios->findItem ( "Cabinets", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
conf.writeEntry( "/qtmame/general/cabinets", temp1 );
cabinets=item->text(1);
//
item=listaDirectorios->findItem ( "Flyers", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
conf.writeEntry( "/qtmame/general/flyers", temp1 );
flyers=item->text(1);
//
item=listaDirectorios->findItem ( "Titles", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
conf.writeEntry( "/qtmame/general/titles", temp1 );
titles=item->text(1);
//
item=listaDirectorios->findItem ( "Marquees", 0, ExactMatch );
temp1=item->text(1);reemplazarBase( temp1,1);
conf.writeEntry( "/qtmame/general/marquees", temp1 );
titles=item->text(1);

//recarga info

QString mameinfodir=conf.readEntry( "/qtmame/general/mameinfo", "~/.xmame/mameinfo.dat" );
QString mamehistorydir=conf.readEntry( "/qtmame/general/mamehistory", "~/.xmame/history.dat" );
QString home2=QDir::homeDirPath();
mameinfodir.replace(QRegExp("~"),home2);
mamehistorydir.replace(QRegExp("~"),home2);

// cargo history
               QFile fh(mamehistorydir);
               if (fh.exists()) {
                    if ( fh.open(IO_ReadOnly) ) {
                         QTextStream t2( &fh );
                         mamehistoryF=t2.read();
                    }
               }
               else{
                    mamehistoryF="";
               }

//
// cargo mameinfo
               QFile fi(mameinfodir);
               if (fi.exists()) {
                    if ( fi.open(IO_ReadOnly) ) {
                         QTextStream t3( &fi );
                         mameinfoF=t3.read();
                    }
               }
               else {
                    mameinfoF="";
               }
// termina la carga de info
//
fxmame=x11->text();
conf.writeEntry( "/qtmame/general/fxmame", fxmame );


mameinfodir.replace(QRegExp("~"),home2);
mamehistorydir.replace(QRegExp("~"),home2);
mameromdirF.replace(QRegExp("~"),home2);
snapshots.replace(QRegExp("~"),home2);
cabinets.replace(QRegExp("~"),home2);
flyers.replace(QRegExp("~"),home2);
titles.replace(QRegExp("~"),home2);
marquees.replace(QRegExp("~"),home2);
fxmame.replace(QRegExp("~"),home2);
argumentosMame.replace(QRegExp("~"),home2);

this->close();
}

void configi::cancelar(){
this->close();
}

void configi::pordefecto(){

//cargar por defecto

moreOptions->setText("");
//x11 input
grabmouseC->setChecked( FALSE );
winkeysC->setChecked( FALSE );
//imput
joytypeC->setCurrentItem( 1 );
analogstickC->setChecked( FALSE );
hotrodC->setChecked( FALSE );
mouseC->setChecked( TRUE );
hotrodseC->setChecked( FALSE );
usbpspadC->setChecked( FALSE );
rapidfireC->setChecked( FALSE );
joydevnameC->setText("");
//sound
samplesS->setChecked( TRUE );
soundS->setChecked( TRUE );
bufsizeS->setText( trUtf8( "3.000000" ) );
audiodeviceS->setText("");
mixerdeviceS->setText("");
samplefreqS->setCurrentItem( 4 );
volumeS->setValue( -3 );
dsppluginS->setText("");
soundmixerpluginS->setText("");
//otros
cheatO->setChecked( TRUE );
skipGameInfoO->setChecked( TRUE );
skipDisclaimerO->setChecked( TRUE );

//video
fullscreenV->setChecked( TRUE );

//directorio
QListViewItem * item;
item=listaDirectorios->findItem ( "Base-Mame", 0, ExactMatch );
item->setText(1, "/mnt/win/mame/");

item=listaDirectorios->findItem ( "Roms", 0, ExactMatch );
item->setText(1, "%BaseMame%roms/");
item=listaDirectorios->findItem ( "Snapshots", 0, ExactMatch );
item->setText(1, "%BaseMame%snap/");
item=listaDirectorios->findItem ( "Cabinets", 0, ExactMatch );
item->setText(1, "%BaseMame%cabinets/");
item=listaDirectorios->findItem ( "Flyers", 0, ExactMatch );
item->setText(1, "%BaseMame%flyers/");
item=listaDirectorios->findItem ( "Titles", 0, ExactMatch );
item->setText(1, "%BaseMame%titles/");
item=listaDirectorios->findItem ( "Marquees", 0, ExactMatch );
item->setText(1, "%BaseMame%marquees/");
item=listaDirectorios->findItem ( "Nvram", 0, ExactMatch );
item->setText(1, "%BaseMame%nvram/");
item=listaDirectorios->findItem ( "Memcard", 0, ExactMatch );
item->setText(1, "%BaseMame%memcard/");
item=listaDirectorios->findItem ( "Input", 0, ExactMatch );
item->setText(1, "%BaseMame%inp/");
item=listaDirectorios->findItem ( "Cfg", 0, ExactMatch );
item->setText(1, "%BaseMame%cfg/");
item=listaDirectorios->findItem ( "Samples", 0, ExactMatch );
item->setText(1, "%BaseMame%samples/");
item=listaDirectorios->findItem ( "Hiscore", 0, ExactMatch );
item->setText(1, "%BaseMame%hi/");
item=listaDirectorios->findItem ( "Artwork", 0, ExactMatch );
item->setText(1, "%BaseMame%artwork/");
item=listaDirectorios->findItem ( "Ctrlr", 0, ExactMatch );
item->setText(1, "%BaseMame%ctrlr/");
item=listaDirectorios->findItem ( "Diff", 0, ExactMatch );
item->setText(1, "%BaseMame%diff/");
item=listaDirectorios->findItem ( "Mameinfo", 0, ExactMatch );
item->setText(1, "%BaseMame%mameinfo.dat");
item=listaDirectorios->findItem ( "History", 0, ExactMatch );
item->setText(1, "%BaseMame%history.dat");
item=listaDirectorios->findItem ( "Cheat", 0, ExactMatch );
item->setText(1, "%BaseMame%cheat.dat");
item=listaDirectorios->findItem ( "HiscoreFile", 0, ExactMatch );
item->setText(1, "%BaseMame%Hiscore.dat");
//
x11->setText("xmame.x11");
}

void configi::leerconfig(){
QString dato;
QString temp1;
QListViewItem * item;
QSettings conf;
bool ok;

if (argumentosMame.compare( "" )==0) {
     pordefecto();
     return;
}
//DIRECTORIOS DE IMAGENES Y BASE
item=listaDirectorios->findItem ( "Base-Mame", 0, ExactMatch );
temp1=conf.readEntry( "/qtmame/general/basemame", "/mnt/win/mame/" );
item->setText(1,temp1);
//
item=listaDirectorios->findItem ( "Snapshots", 0, ExactMatch );
temp1=conf.readEntry( "/qtmame/general/snapshots", "%BaseMame%snap/" );
reemplazarBase( temp1,0);
item->setText(1,temp1);
//
item=listaDirectorios->findItem ( "Cabinets", 0, ExactMatch );
temp1=conf.readEntry( "/qtmame/general/cabinets", "%BaseMame%cabinets/" );
reemplazarBase( temp1,0);
item->setText(1,temp1);
//
item=listaDirectorios->findItem ( "Flyers", 0, ExactMatch );
temp1=conf.readEntry( "/qtmame/general/flyers", "%BaseMame%flyers/" );
reemplazarBase( temp1,0);
item->setText(1,temp1);
//
item=listaDirectorios->findItem ( "Titles", 0, ExactMatch );
temp1=conf.readEntry( "/qtmame/general/Titles", "%BaseMame%titles/" );
reemplazarBase( temp1,0);
item->setText(1,temp1);
//
item=listaDirectorios->findItem ( "Marquees", 0, ExactMatch );
temp1=conf.readEntry( "/qtmame/general/marquees", "%BaseMame%marquees/" );
reemplazarBase( temp1,0);
item->setText(1,temp1);
//


QStringList mame = QStringList::split( " ", argumentosMame );
QStringList::Iterator it = mame.begin();
++it;
dato=*it;

//SONIDO extra
if (dato.compare( "-dsp-plugin" )==0){
     ++it;
     dsppluginS->setText(*it);
     ++it;
}
else{
     dsppluginS->setText("");
}
//
//++it; no avanza por anterior
dato=*it;if (dato.compare( "-sound-mixer-plugin" )==0){
     ++it;
     soundmixerpluginS->setText(*it);
     ++it;
}    
else{
     soundmixerpluginS->setText("");
}


//SONIDO NORMAL
// ++it;no avanza por el anterior
dato=*it;if (dato.compare( "-sound" )==0){
     soundS->setChecked(1);
}
else{
     soundS->setChecked(0);
}
//
++it;
dato=*it;if (dato.compare( "-samples" )==0){
     samplesS->setChecked(1);
}
else{
     samplesS->setChecked(0);
}
//
++it;
++it;
dato=*it;if (dato.toInt( &ok, 10 )==8000) samplefreqS->setCurrentItem(0);
else if (dato.toInt( &ok, 10 )==11050) samplefreqS->setCurrentItem(1);
else if (dato.toInt( &ok, 10 )==16000) samplefreqS->setCurrentItem(2);
else if (dato.toInt( &ok, 10 )==22000) samplefreqS->setCurrentItem(3);
else if (dato.toInt( &ok, 10 )==22050) samplefreqS->setCurrentItem(4);
else if (dato.toInt( &ok, 10 )==22100) samplefreqS->setCurrentItem(5);
else if (dato.toInt( &ok, 10 )==44000) samplefreqS->setCurrentItem(6);
else if (dato.toInt( &ok, 10 )==44100) samplefreqS->setCurrentItem(7);
else if (dato.toInt( &ok, 10 )==44800) samplefreqS->setCurrentItem(8);
//
++it;
++it;
dato=*it;
bufsizeS->setText(dato);
//
++it;
++it;
dato=*it;
volumeS->setValue(dato.toInt( &ok, 10 ));
//
++it;
dato=*it;if (dato.compare( "-audiodevice" )==0){
     ++it;
     audiodeviceS->setText(*it);
     ++it;
}
else{
     audiodeviceS->setText("");
}
//++it; no avanza por el anterior
dato=*it;if (dato.compare( "-mixerdevice" )==0){
     ++it;
     mixerdeviceS->setText(*it);
     ++it;
}
else{
     mixerdeviceS->setText("");
}
//++it; no avanza por el anterior

//INPUT
//
++it;
dato=*it;
joytypeC->setCurrentItem(dato.toInt( &ok, 10 ));    
// 
++it;
dato=*it;
if (dato.compare( "-analogstick" )==0){
     analogstickC->setChecked(1);
}
else{
     analogstickC->setChecked(0);
}
//
++it;
dato=*it;
if (dato.compare( "-mouse" )==0){
     mouseC->setChecked(1);
}
else{
     mouseC->setChecked(0);
}
//
++it;
dato=*it;
if (dato.compare( "-hotrod" )==0){
     hotrodC->setChecked(1);
}
else{
     hotrodC->setChecked(0);
}
//
++it;
dato=*it;
if (dato.compare( "-hotrodse" )==0){
     hotrodseC->setChecked(1);
}
else{
     hotrodseC->setChecked(0);
}
//
++it;
dato=*it;
if (dato.compare( "-usbpspad" )==0){
     usbpspadC->setChecked(1);
}
else{
     usbpspadC->setChecked(0);
}
//
++it;
dato=*it;
if (dato.compare( "-rapidfire" )==0){
     rapidfireC->setChecked(1);
}
else{
     rapidfireC->setChecked(0);
}
//
++it;
dato=*it;
if (dato.compare( "-grabmouse" )==0){
     grabmouseC->setChecked(1);
}
else{
     grabmouseC->setChecked(0);
}
//
++it;
dato=*it;
if (dato.compare( "-winkeys" )==0){
     winkeysC->setChecked(1);
}
else{
     winkeysC->setChecked(0);
}
//
++it;
dato=*it;if (dato.compare( "-joydevname" )==0){
     ++it;
     joydevnameC->setText(*it);
     ++it;
}
else{
     joydevnameC->setText("");
}
//
//++it; no avanza por el anterior
dato=*it;
if (dato.compare( "-cheat" )==0){
     cheatO->setChecked(1);
}
else{
     cheatO->setChecked(0);
}
//
++it;
dato=*it;
if (dato.compare( "-skip_gameinfo" )==0){
     skipGameInfoO->setChecked(1);
}
else{
     skipGameInfoO->setChecked(0);
}
//
++it;
dato=*it;
if (dato.compare( "-skip_disclaimer" )==0){
     skipDisclaimerO->setChecked(1);
}
else{
     skipDisclaimerO->setChecked(0);
}

//VIDEO
//
++it;
dato=*it;
if (dato.compare( "-fullscreen" )==0){
     fullscreenV->setChecked(1);
}
else{
     fullscreenV->setChecked(0);
}

//DIRECTORIOS
++it;
//
item=listaDirectorios->findItem ( "Mameinfo", 0, ExactMatch );
dato=*it;if (dato.compare( "-mameinfo_file" )==0){
     ++it;
     reemplazarBase( *it,0);
     item->setText(1,*it);
     ++it;
}
else{
     item->setText(1,"");
     ++it;     ++it;
}
//
item=listaDirectorios->findItem ( "History", 0, ExactMatch );
dato=*it;if (dato.compare( "-history_file" )==0){
     ++it;
     reemplazarBase( *it,0);
     item->setText(1,*it);
     ++it;
}
else{
     item->setText(1,"");
     ++it;     ++it;
}
//
item=listaDirectorios->findItem ( "Cheat", 0, ExactMatch );
dato=*it;if (dato.compare( "-cheat_file" )==0){
     ++it;
     reemplazarBase( *it,0);
     item->setText(1,*it);
     ++it;
}
else{
     item->setText(1,"");
     ++it;     ++it;
}
//
item=listaDirectorios->findItem ( "HiscoreFile", 0, ExactMatch );
dato=*it;if (dato.compare( "-hiscore_file" )==0){
     ++it;
     reemplazarBase( *it,0);
     item->setText(1,*it);
     ++it;
}
else{
     item->setText(1,"");
     ++it;     ++it;
}
//
item=listaDirectorios->findItem ( "Snapshots", 0, ExactMatch );
dato=*it;if (dato.compare( "-snapshot_directory" )==0){
     ++it;
     reemplazarBase( *it,0);
     item->setText(1,*it);
     ++it;
}
else{
     item->setText(1,"");
     ++it;     ++it;
}
//
item=listaDirectorios->findItem ( "Nvram", 0, ExactMatch );
dato=*it;if (dato.compare( "-nvram_directory" )==0){
     ++it;
     reemplazarBase( *it,0);
     item->setText(1,*it);
     ++it;
}
else{
     item->setText(1,"");
     ++it;     ++it;
}
//
item=listaDirectorios->findItem ( "Memcard", 0, ExactMatch );
dato=*it;if (dato.compare( "-memcard_directory" )==0){
     ++it;
     reemplazarBase( *it,0);
     item->setText(1,*it);
     ++it;
}
else{
     item->setText(1,"");
     ++it;     ++it;
}
//
item=listaDirectorios->findItem ( "Input", 0, ExactMatch );
dato=*it;if (dato.compare( "-input_directory" )==0){
     ++it;
     reemplazarBase( *it,0);
     item->setText(1,*it);
     ++it;
}
else{
     item->setText(1,"");
     ++it;     ++it;
}
//
item=listaDirectorios->findItem ( "Cfg", 0, ExactMatch );
dato=*it;if (dato.compare( "-cfg_directory" )==0){
     ++it;
     reemplazarBase( *it,0);
     item->setText(1,*it);
     ++it;
}
else{
     item->setText(1,"");
     ++it;     ++it;
}
//
item=listaDirectorios->findItem ( "Samples", 0, ExactMatch );
dato=*it;if (dato.compare( "-samplepath" )==0){
     ++it;
     reemplazarBase( *it,0);
     item->setText(1,*it);
     ++it;
}
else{
     item->setText(1,"");
     ++it;     ++it;
}
//
item=listaDirectorios->findItem ( "Hiscore", 0, ExactMatch );
dato=*it;if (dato.compare( "-hiscore_directory" )==0){
     ++it;
     reemplazarBase( *it,0);
     item->setText(1,*it);
     ++it;
}
else{
     item->setText(1,"");
     ++it;     ++it;
}
//
item=listaDirectorios->findItem ( "Artwork", 0, ExactMatch );
dato=*it;if (dato.compare( "-artwork_directory" )==0){
     ++it;
     reemplazarBase( *it,0);
     item->setText(1,*it);
     ++it;
}
else{
     item->setText(1,"");
     ++it;     ++it;
}
//
item=listaDirectorios->findItem ( "Ctrlr", 0, ExactMatch );
dato=*it;if (dato.compare( "-ctrlr_directory" )==0){
     ++it;
     reemplazarBase( *it,0);
     item->setText(1,*it);
     ++it;
}
else{
     item->setText(1,"");
     ++it;     ++it;
}
//
item=listaDirectorios->findItem ( "Diff", 0, ExactMatch );
dato=*it;if (dato.compare( "-diff_directory" )==0){
     ++it;
     reemplazarBase( *it,0);
     item->setText(1,*it);
     ++it;
}
else{
     item->setText(1,"");
     ++it;     ++it;
}
//
item=listaDirectorios->findItem ( "Roms", 0, ExactMatch );
dato=*it;if (dato.compare( "-rompath" )==0){
     ++it;
     reemplazarBase( *it,0);
     item->setText(1,*it);
     ++it;
}
else{
     item->setText(1,"");
     ++it;     ++it;
}
     // more options
     dato="";
     if (*it) {
          dato.append(*it);
                ++it;
          while (*it ) {    
               dato.append(" ");
               dato.append(*it);
                ++it;
          }
          moreOptions->setText(dato);
     }
                
//    
//QMessageBox::information( this, "prueba", *it );
}

void configi::listaDirectorios_mouseButtonClicked( int boton, QListViewItem * item, const QPoint &pos, int col){
int itemElegido;
QString baseElegido;
QString directorioElegido;
int directorio=1;

QPopupMenu *dirMenu = new QPopupMenu;       // file sub menu
dirMenu->insertItem( tr("Seleccionar Path..."), 1 );
dirMenu->insertItem( tr("Editar Path"), 2 );
itemElegido=dirMenu->exec(pos);

if (itemElegido==2) {
     item->setRenameEnabled ( 1, TRUE );
     item->startRename(1);
}
else if (itemElegido==1) {
     QListViewItem * itemBase;
     itemBase=listaDirectorios->findItem ( "Base-Mame", 0, ExactMatch );

     if (item->text(0).compare("Mameinfo")==0) directorio=0;     
     else if (item->text(0).compare("History")==0) directorio=0;
     else if (item->text(0).compare("Cheat")==0) directorio=0;
     else if (item->text(0).compare("Hiscore")==0) directorio=0;

     if(directorio){
          directorioElegido=QFileDialog::getExistingDirectory(itemBase->text(1),this,tr("Elegir un directorio"),tr("Seleccione el directorio de: ") + item->text(0), TRUE );
     }
     else{
          directorioElegido=QFileDialog::getOpenFileName(itemBase->text(1),"*",this,tr("Elegir un Archivo"),tr("Seleccione el Archivo de: ") + item->text(0));
     }
     
     if(directorioElegido.compare("")!=0){
         if (item!=itemBase) {
               reemplazarBase(directorioElegido,0);           
         } 
         item->setText(1,directorioElegido);
     }
}
   
}
void configi::reemplazarBase(QString &original,int StringXpath){

QString principioOriginal;
                       
if (StringXpath==0){
     QListViewItem * itemBase;
     itemBase=listaDirectorios->findItem ( "Base-Mame", 0, ExactMatch );
     principioOriginal=original.left(itemBase->text(1).length ());
     if (principioOriginal.compare(itemBase->text(1))==0) {
          original.replace(0,itemBase->text(1).length (),"%BaseMame%");
     }
}
else{
     QListViewItem * itemBase;
     itemBase=listaDirectorios->findItem ( "Base-Mame", 0, ExactMatch );
     original.replace( QRegExp("%BaseMame%",TRUE), itemBase->text(1) );
}

}
